package dev.shadowsoffire.apotheosis.ench.table;

import net.minecraft.world.item.crafting.Recipe;
import org.apache.commons.lang3.tuple.Pair;
import net.minecraftforge.common.crafting.CraftingHelper;
import com.google.gson.JsonObject;
import net.minecraft.world.item.crafting.RecipeSerializer;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.ItemStack;
import net.minecraft.resources.ResourceLocation;

public class KeepNBTEnchantingRecipe extends EnchantingRecipe
{
    public static final Serializer SERIALIZER;
    
    public KeepNBTEnchantingRecipe(final ResourceLocation id, final ItemStack output, final Ingredient input, final EnchantingStatRegistry.Stats requirements, final EnchantingStatRegistry.Stats maxRequirements) {
        super(id, output, input, requirements, maxRequirements);
    }
    
    @Override
    public ItemStack assemble(final ItemStack input, final float eterna, final float quanta, final float arcana) {
        final ItemStack out = this.getOutput().m_41777_();
        if (input.m_41782_()) {
            out.m_41751_(input.m_41783_().m_6426_());
        }
        return out;
    }
    
    @Override
    public RecipeSerializer<?> m_7707_() {
        return (RecipeSerializer<?>)KeepNBTEnchantingRecipe.SERIALIZER;
    }
    
    static {
        SERIALIZER = new Serializer();
    }
    
    public static class Serializer extends EnchantingRecipe.Serializer
    {
        @Override
        public KeepNBTEnchantingRecipe fromJson(final ResourceLocation id, final JsonObject obj) {
            final ItemStack output = CraftingHelper.getItemStack(obj.get("result").getAsJsonObject(), true, true);
            final Ingredient input = Ingredient.m_43917_(obj.get("input"));
            final Pair<EnchantingStatRegistry.Stats, EnchantingStatRegistry.Stats> requirements = EnchantingRecipe.readStats(id, obj);
            return new KeepNBTEnchantingRecipe(id, output, input, requirements.getLeft(), requirements.getRight());
        }
    }
}
